Program Dgraff;

Uses DfosR, Struct, Dos ;

Type

Graffrec        = Record
                   Fcol : Byte ;
                   Bcol : Byte ;
                   Chr  : char ;
                  End ;


Var

i2              : Integer ;
Endje           : Byte ;
i,ii,iii        : Byte ;
wnw             : Byte ;
fcol,bcol       : Byte ;
xpos,ypos       : Byte ;
DrawAr          : Array[1..1680] of Graffrec ;
DrawFile        : File of Graffrec ;
DrawLoad        : Graffrec ;
Dirinfo         : SearchRec ;
FileString      : String ;
DrawMode        : Boolean ;

Const

EditBottom      = '[0;1;30m۲[[0m1=[1;30m[0m2=[1;30m[0m3=[1;30m[0m4=[1;30m[0m5=[1;30m'+
                  '[0m6=[1;30m[0m7=[1;30m[0m8=[1;30m]۲[[0mCtrl-I=Help[1;30m][ '+
                  '[0mNormalMode[1;30m ]';
FileBottom      = '[0;1;30m۲[[0mEnter Filename : [1;30m ]';

LineTop         = '[0;1;30m۲[                      ]۱[ Foreground Color ..  Background Color .. ]';

LineBottom      = '[0;1;30m۲[ [0mQuit [1;30m]۲[ [0mEdit [1;30m]۲[ [0mLoad [1;30m]۲[ [0mSave '+
                  '[1;30m]۲[ [0mHelp [1;30m]';
LineX           : Array[1..5] of byte = (11,24,37,50,63);
LineStr         : Array[1..5] of String = (' Quit ',' Edit ',' Load ',' Save ',' Help ');
EhelpAr         : Array[1..14] of String = (
                  '       Dgraff(itti) Edit-HelpScreen',
                  ' ',' ',
                  ' Ctrl-F = Increase Foreground Color',
                  ' Ctrl-B = Increase Background Color',
                  ' Ctrl-D = Toggle Drawmode On/Off',
                  ' DrawMode Keys 1-8 Explained At Bottom',
                  ' Ctrl-L = Clear-Line',
                  ' Home   = Jump To Begin Of Line',
                  ' End    = Jump To End Of Line',
                  ' Escape = Return To Dgraff-Main',
                  ' ',' ',
                  '     Press Enter To Continue Editing');
HelpAr          : Array[1..19] of String =(
                  ' Welcome To Dgraff(itti).',
                  ' ',' ',
                  ' A Brand New Way Of Walling Appears For You Now.',
                  ' ',
                  ' Enter The Edit Mode And Create Your Own Screen.',
                  ' Load/Save/Modify Screens From Others',
                  ' Just Take A Closer Look And Enjoy Dgraff.',
                  ' ',
                  ' If You Want Your Screen To Be Loaded As Default',
                  ' Simply Save Your File And Name It GRAFF1.',
                  ' ',
                  ' Inside Edit-Mode Use Cursors/End/Home Or Ctrl-I For Help.',
                  ' ',
                  ' Note : Escaping From Edit-Mode To Dgraff-Main Does Not',
                  '        Save Your File, Execute Save.',
                  ' ',
                  ' Now Press Enter To Return To Dgraff-Main. ',
                  ' ');


Procedure StartUp ; {Startup Screen}
Begin
 clearscreen;
 Fcol:=7;
 Bcol:=0;
 Fwrite(goxy(1,1)+LineTop);
 Fwrite(goxy(1,23)+LineBottom);
 Fwrite(goxy(7,1)+color(7,0)+' Inside Dgraff Main  ');
 Findfirst(Paramstr(4)+'graff1.iti',Archive,Dirinfo);
 if Doserror = 0 then begin
  Assign(drawfile,Paramstr(4)+'graff1.iti');
  {$I-} Reset(drawfile); {$I+}
  if Ioresult <> 0 then Rewrite(drawfile) else ;

  for i := 0 to 20 do
   begin
    for ii := 1 to 80 do
     begin
      Read(DrawFile,DrawLoad);
      DrawAr[ii+80*i] := DrawLoad ;
       if DrawLoad.Chr in [#0,#32] then else
       Fwrite(goxy(ii,1+i)+Color(DrawLoad.Fcol+1,DrawLoad.Bcol)+DrawLoad.Chr);
     end;
   end;

  end else ;

End;

Procedure ShowLoad(LoadFile:String);
Begin
 ClearScreen;
 Fwrite(goxy(1,1)+LineTop);
 Fwrite(goxy(1,23)+LineBottom);
 Fwrite(goxy(7,1)+color(7,0)+' Inside Dgraff Main  ');
 Findfirst(Paramstr(4)+LoadFile+'.iti',Archive,Dirinfo);
 if Doserror = 0 then begin
  Assign(drawfile,Paramstr(4)+LoadFile+'.iti');
  {$I-} Reset(drawfile); {$I+}
  if Ioresult <> 0 then Rewrite(drawfile) else ;

  for i := 0 to 20 do
   begin
    for ii := 1 to 80 do
     begin
      Read(DrawFile,DrawLoad);
      DrawAr[ii+80*i] := DrawLoad ;
       if DrawLoad.Chr in [#0,#32] then else
       Fwrite(goxy(ii,1+i)+Color(DrawLoad.Fcol+1,DrawLoad.Bcol)+DrawLoad.Chr);
     end;
   end;

  end else ;
 Fwrite(goxy(1,1)+LineTop);
 Fwrite(goxy(1,23)+LineBottom);
 Fwrite(goxy(7,1)+color(7,0)+' Inside Dgraff Main  ');
 Fwrite(color(fcol,0)+goxy(52,1)+'xx'+Color(bcol,0)+goxy(73,1)+'xx');
 iii := 1 ;
 Fwrite(color(15,7)+goxy(LineX[iii],23)+LineStr[iii]);
End;


Procedure DrawOnly;
Begin
 for i := 0 to 20 do
   begin
    for ii := 1 to 80 do
     begin
      DrawLoad := DrawAr[ii+80*i] ;
       if DrawLoad.Chr in [#0,#32] then else Fwrite(goxy(ii,1+i)+Color(DrawLoad.Fcol+1,DrawLoad.Bcol)+DrawLoad.Chr);
   end;
 end;
End;

Procedure EditHelp;
Begin
 Clearscreen;
 Fwrite(goxy(1,1)+LineTop);
 Fwrite(color(7,0)+goxy(7,1)+' Editing HelpScreen  ');
 Fwrite(color(fcol,0)+goxy(52,1)+'xx'+Color(bcol,0)+goxy(73,1)+'xx');
 Fwrite(goxy(1,23)+EditBottom);
 For i := 1 to 14 do
  begin
   Fwrite(goxy(20,3+i)+color(11,0)+EhelpAr[i]);
  end;
 Repeat
  key:=ReadKey;
 Until Key = #13 ;
 Clearscreen;
 Fwrite(goxy(1,1)+LineTop);
 Fwrite(color(7,0)+goxy(7,1)+' Editing Sumthing    ');
 Fwrite(color(fcol,0)+goxy(52,1)+'xx'+Color(bcol,0)+goxy(73,1)+'xx');
 Fwrite(goxy(1,23)+EditBottom);

End;

Procedure Main;
Begin
 Fwrite(goxy(1,1)+LineTop);
 Fwrite(goxy(1,23)+LineBottom);
 Fwrite(goxy(7,1)+color(7,0)+' Inside Dgraff Main  ');
 Fwrite(color(fcol,0)+goxy(52,1)+'xx'+Color(bcol,0)+goxy(73,1)+'xx');
 iii := 1 ;
 Fwrite(color(15,7)+goxy(LineX[iii],23)+LineStr[iii]);
 Repeat
  Key := ReadKey ;
  ii := iii ;
   Case key of
    #13  : begin
           Fwrite(color(7,0));
           Endje := 1 ;
           end;
    #204 : begin
           inc(iii) ;
           if iii > 5 then iii := 1 else ;
           Fwrite(color(7,0)+goxy(LineX[ii],23)+LineStr[ii]);
           Fwrite(color(15,7)+goxy(LineX[iii],23)+LineStr[iii]);
           end;
    #206 : begin
           dec(iii) ;
           if iii < 1 then iii := 5 else ;
           Fwrite(color(7,0)+goxy(LineX[ii],23)+LineStr[ii]);
           Fwrite(color(15,7)+goxy(LineX[iii],23)+LineStr[iii]);
           end;
   End; {case end}

 Until Endje = 1 ;
End;

Procedure ClearLine;
Begin
 for i := 1 to 80 do
  begin
   Fwrite(goxy(i,ypos)+Color(fcol,bcol)+#32);
   DrawAr[i-1+xpos+(ypos-1)*80].Chr  := #32 ;
   DrawAr[i-1+xpos+(ypos-1)*80].fcol := fcol-1 ;
   DrawAr[i-1+xpos+(ypos-1)*80].bcol := 0 ;
  end;
End;


Procedure Edit;
Begin
 DrawMode := False ;
 Fwrite(color(7,0)+goxy(7,1)+' Editing Sumthing    ');
 Fwrite(color(fcol,0)+goxy(52,1)+'xx'+Color(bcol,0)+goxy(73,1)+'xx');
 Fwrite(goxy(1,23)+EditBottom);
 xpos := 1 ;
 ypos := 2 ;
 Fwrite(goxy(xpos,ypos)+color(fcol,bcol));
 Repeat
 wnw:=1;
 key := ReadKey ;
 if (key<#30) or (key>#126) then wnw:=0;
  Case Key of
   #4  : Begin
          If DrawMode = False Then
           Begin
            DrawMode := True ;
            Fwrite(Goxy(64,23)+Color(7,0)+'DrawMode  ');
           End Else
            Begin
             DrawMode := False ;
             Fwrite(Goxy(64,23)+Color(7,0)+'NormalMode');
            End;
         End;
   #12 : clearline; {ctrl-L}
   #13 : begin {enter}
         xpos:=1;
         inc(ypos);
         if ypos=23 then ypos:=22;
         end;
   #49 : begin
         wnw:=1;
         if DrawMode = True Then key:=#176;
         end;
   #50 : begin
         wnw:=1;
         if DrawMode = True Then key:=#177;
         end;
   #51 : begin
         wnw:=1;
         if DrawMode = True Then key:=#178;
         end;
   #52 : begin
         wnw:=1;
         if DrawMode = True Then key:=#219;
         end;
   #53 : begin
         wnw:=1;
         if DrawMode = True Then key:=#223;
         end;
   #54 : begin
         wnw:=1;
         if DrawMode = True Then key:=#220;
         end;
   #55 : begin
         wnw:=1;
         if DrawMode = True Then key:=#221;
         end;
   #56 : begin
         wnw:=1;
         if DrawMode = True Then key:=#222;
         end;
   #200: begin
         dec(ypos);
         if ypos=1 then ypos:=2 ;
         wnw:=0;
         end;
   #208: begin
         inc(ypos);
         if ypos=23 then ypos:=22;
         wnw:=0;
         end;
   #204: begin
         inc(xpos);
         if xpos=81 then xpos:=80;
         wnw:=0;
         end;
   #206: begin
         dec(xpos);
         if xpos=0 then xpos:=1;
         wnw:=0;
         end;
   #27 : begin {escape}
         wnw:=0;
         endje := 6 ;
         end;
   #228: begin {escape}
         wnw:=0;
         endje := 6 ;
         end;
   #6: begin {increase fcol}
         wnw:=0;
         inc(fcol);
         if fcol=16 then fcol:=0;
         end;
   #2: begin {increase bcol}
         wnw:=0;
         inc(bcol);
         if bcol=8 then bcol:=0;
         end;
   #8  : begin {delete}
         dec(xpos);
         if xpos=0 then xpos:=1;
         Fwrite(goxy(xpos,ypos)+#32);
         DrawAr[xpos+(ypos-1)*80].Chr := #32 ;
         end;
   #9  : begin
         EditHelp;
         DrawOnly;
         end;
   #196: begin {end}
         xpos := 80 ;
         end;
   #197: begin {home}
         xpos := 1 ;
         end;
   end; {end case}

 Fwrite(color(fcol,0)+goxy(52,1)+'xx'+Color(bcol,0)+goxy(73,1)+'xx');
 if wnw=0 then Fwrite(color(fcol,bcol)+goxy(xpos,ypos));
 if wnw=1 then
  begin
   DrawAr[xpos+(ypos-1)*80].Chr  := Key ;
   DrawAr[xpos+(ypos-1)*80].fcol := fcol-1 ;
   DrawAr[xpos+(ypos-1)*80].bcol := bcol ;
   Fwrite(goxy(xpos,ypos)+color(fcol,bcol)+key);
   inc(xpos);
   if xpos=81 then xpos:=80;
   end else ;
 Until endje = 6 ;

End;

Procedure Load;
Begin
 FileString := '' ;
 ii := 0 ;
 i := 0 ;
 ClearScreen;
 Fwrite(goxy(1,1)+LineTop);
 Fwrite(goxy(7,1)+color(7,0)+' Showing Directory   ');
 Fwrite(goxy(1,3)+color(7,0));
 FindFirst(ParamStr(4)+'*.iti', Archive, DirInfo);
  while DosError = 0 do
   begin
    Fwrite(goxy(1+ii*12,i+3)+DirInfo.Name+Newline);
    FindNext(DirInfo);
    inc(i);
    if i=22 then begin
     inc(ii);
     i := 0 ;
     end else ;
   end;
 Fwrite(goxy(1,23)+FileBottom);
 FileString := Fread(FileString,29,23,8,7,0);
 if FileString = '' then Begin
  ClearScreen;
  Fwrite(goxy(1,1)+LineTop);
  Fwrite(goxy(1,23)+LineBottom);
  Fwrite(goxy(7,1)+color(7,0)+' Inside Dgraff Main  ');
  DrawOnly;
  Fwrite(color(fcol,0)+goxy(52,1)+'xx'+Color(bcol,0)+goxy(73,1)+'xx');
  iii := 1 ;
  Fwrite(color(15,7)+goxy(LineX[iii],23)+LineStr[iii]);
  end else begin
  For i2 := 1 to 1680 do
   begin
    DrawAr[i2].Chr  := #0 ;
    DrawAr[i2].fcol := 0 ;
    DrawAr[i2].bcol := 0 ;
   end;
  ShowLoad(Filestring);
  end;
 Endje := 6 ;
End;

Procedure Save;
Begin
 FileString := '' ;
 Fwrite(goxy(1,23)+FileBottom);
 FileString := Fread(FileString,29,23,8,7,0);
 if Filestring = '' then
 begin
  Fwrite(goxy(7,1)+color(7,0)+' Aborting FileSaving ');
 end else
  begin
   Fwrite(goxy(7,1)+color(7,0)+' Saving Some Shit    ');
   Assign(DrawFile,Paramstr(4)+FileString+'.iti');
   {$I-} Reset(DrawFile); {$I+}
   if Ioresult <> 0 then Rewrite(DrawFile) Else Rewrite(DrawFile);
   for i2 := 1 to 1680 do
    begin
     Write(DrawFile,DrawAr[i2]);
    end;
   end;
 Delay(50);
 Endje := 6 ;
End;

Procedure Help;
Begin
 Clearscreen;
 Fwrite(goxy(1,1)+LineTop);
 Fwrite(color(7,0)+goxy(7,1)+' Dgraff HelpScreen   ');
 Fwrite(color(fcol,0)+goxy(52,1)+'xx'+Color(bcol,0)+goxy(73,1)+'xx');
 Fwrite(goxy(1,23)+LineBottom);
 For i := 1 to 19 do
  begin
   Fwrite(goxy(5,2+i)+color(11,0)+HelpAr[i]);
  end;
 Repeat
  key:=ReadKey;
 Until Key = #13 ;
 Clearscreen;
 Fwrite(goxy(1,1)+LineTop);
 Fwrite(color(7,0)+goxy(7,1)+' Inside Dgraff Main  ');
 Fwrite(color(fcol,0)+goxy(52,1)+'xx'+Color(bcol,0)+goxy(73,1)+'xx');
 Fwrite(goxy(1,23)+LineBottom);
 DrawOnly;
 Endje := 6 ;
End;

Begin
 Fwrite(goxy(1,1)+LineTop);
 Fwrite(goxy(1,23)+LineBottom);
 Fwrite(goxy(7,1)+color(7,0)+' Inside Dgraff Main  ');
 StartUp;
 Repeat
 Main;
 if iii = 1 then endje := 2 ;
 if iii = 2 then edit ;
 if iii = 3 then load ;
 if iii = 4 then save ;
 if iii = 5 then help ;
 if iii = 6 then iii := 1 ;
 Until Endje = 2 ;
 Clearscreen;
 Fwrite(goxy(1,1)+Color(7,0)+'You Just Witnessed Dgraff');
 Fwrite(goxy(1,2)+Color(7,0)+'a Damnation 1995 Production By Valocity');
 Delay(50);
End.
