Program Darsel;

Uses Dfos, Dos, Struct ;

Type
 InfoRecord = Record
               InfoLine1,
               InfoLine2,
               InfoLine3  : String ;
              End;

Var
 GroupRec   : GroupRecord ;
 GroupFile  : File of GroupRecord ;
 FileRec    : FilesRecord ;
 FileFile   : File of FilesRecord ;
 AnsiChr    : Char ;
 AnsiFile   : Text ;
 GroupAr    : Array[1..20] of GroupRecord ;
 FileAr     : Array[1..20] of FilesRecord ;
 Xpos,
 Ypos,
 Fcol,
 Bcol,
 FLcol,
 BLcol,
 StrLen     : Byte ;
 GroupMax,
 FileMax    : Word ;
 i,ii       : Word ;
 InfoFile   : Text ;
 InfoAr     : Array[1..20] of InfoRecord ;
 InfoStr    : String ;
 MaxInfoL   : Byte ;


Procedure ReadInfo(FileNamex:String);
 Begin
  ii := 1 ;
  Assign(InfoFile,Paramstr(4)+FileNamex);
  {$I-} Reset(InfoFile); {$I+}
  While Not Eof(InfoFile) do
   Begin
    ReadLn(InfoFile,InfoAr[ii].InfoLine1);
    ReadLn(InfoFile,InfoAr[ii].InfoLine2);
    ReadLn(InfoFile,InfoAr[ii].InfoLine3);
    ReadLn(InfoFile,InfoStr);
    Inc(ii);
   End;
  Close(InfoFile);
 End;

Procedure WriteInfo;
 Begin
  Fwrite(Goxy(12,18)+Color(7,0)+InfoAr[i].InfoLine1);
  Fwrite(Goxy(12,19)+Color(7,0)+InfoAr[i].InfoLine2);
  Fwrite(Goxy(12,20)+Color(7,0)+InfoAr[i].InfoLine3);
 End;

Procedure DeleteInfo;
 Const
  DelInfo = '                                                           ' ;
 Begin
  Fwrite(Color(8,0));
  Fwrite(Goxy(12,18)+DelInfo);
  Fwrite(Goxy(12,19)+DelInfo);
  Fwrite(Goxy(12,20)+DelInfo);
 End;

Procedure StartUp;
 Begin
  Ypos   := 4 ;
  Xpos   := 20 ;
  Fcol   := 7 ;
  Bcol   := 0 ;
  FLcol  := 15 ;
  BLcol  := 5 ;
  StrLen := 40 ;
  ClearScreen;

 End;

Function Center(Str2Center:String):String;
 Var
  Temp1,
  Temp2 : Byte ;
 Begin
  Temp1 := 20 - (Length(Str2Center) Div 2);
  For Temp2 := 1 to Temp1 do
   Begin
    Str2Center := ' '+Str2Center+' ' ;
   End;
  Center := Str2Center ;
 End;

Procedure CountGroup;
 Var
  Counter   : Word ;
 Begin
  Assign(GroupFile,Rapad+'FGroups.Ra');
  {$I-} Reset(GroupFile); {$I+}
  Counter := 1 ;
  Repeat;
   Read(GroupFile,GroupRec);
    If GroupRec.Security <= Erec.Userinfo.Security Then
     Begin
      GroupAr[Counter] := GroupRec ;
      if GroupRec.Security = 0 Then Else Inc(Counter);
     End Else ;
  Until (Eof(GroupFile)) or (GroupRec.Name = '');
   GroupMax := Counter-1 ;
  For Counter := 1 to GroupMax do
   Begin
    GroupAr[Counter].Name := Center(GroupAr[Counter].Name);
   End;
 Close(GroupFile);
 End;

Procedure CountFile;
 Var
  LamaSien  : Boolean ;
  Counter2  : Byte ;
  Counter   : Word ;
 Begin
  Assign(FileFile,Rapad+'Files.Ra');
  {$I-} Reset(FileFile); {$I+}
  Counter := 1 ;
  Counter2 := 1 ;
  If Erec.Userinfo.Group = 0 Then
   Begin
    Erec.Userinfo.Group := 1 ;
    Erec.Userinfo.Filearea := 1 ;
   End Else ;
  Repeat
   LamaSien := False ;
   Read(FileFile,FileRec);
    If (Erec.Userinfo.Security >= FileRec.Security) Then LamaSien := True ;
    If (LamaSien = True) Then
     Begin
      If (Erec.Userinfo.Group = FileRec.Group) or
         (Erec.Userinfo.Group = FileRec.AltGroup[1]) or
         (Erec.Userinfo.Group = FileRec.AltGroup[2]) or
         (Erec.Userinfo.Group = FileRec.AltGroup[3]) Then LamaSien := True Else LamaSien := False ;
     End Else ;
    If LamaSien = True Then
     Begin
      FileAr[Counter] := FileRec ;
      FileAr[Counter].FreeSpace[1] := Counter2 ;
      Inc(Counter);
     End Else ;
   Inc(Counter2);
  Until (Eof(FileFile)) or (FileRec.Name = '');
   FileMax := Counter-1 ;
  For Counter := 1 to FileMax do
   Begin
    FileAr[Counter].Name := Center(FileAr[Counter].Name);
   End;
 Close(FileFile);
 End;

Procedure ShowGroup;
 Var
  Counter : Word ;
 Begin
  Assign(AnsiFile,Paramstr(4)+'Confs.Ans');
  {$I-} Reset(AnsiFile); {$I+}
  While Not Eof(AnsiFile) Do
   Begin
    Read(AnsiFile,AnsiChr);
    Fwrite(AnsiChr);
   End;
  Close(AnsiFile);
  For Counter := 1 to GroupMax Do
   Begin
    Fwrite(Goxy(Xpos,Ypos+Counter)+Color(Fcol,Bcol)+GroupAr[Counter].Name);
   End;
 End;

Procedure ShowFile;
 Var
  Counter : Word ;
 Begin
  Assign(AnsiFile,Paramstr(4)+'Sects.Ans');
  {$I-} Reset(AnsiFile); {$I+}
  While Not Eof(AnsiFile) Do
   Begin
    Read(AnsiFile,AnsiChr);
    Fwrite(AnsiChr);
   End;
  Close(AnsiFile);
  For Counter := 1 to FileMax Do
   Begin
    Fwrite(Goxy(Xpos,Ypos+Counter)+Color(Fcol,Bcol)+FileAr[Counter].Name);
   End;
 End;

Procedure Section ;
 Begin
  CountFile;
  ShowFile;
  Repeat
  Inc(i);
  Until FileAr[i].FreeSpace[1] = Erec.Userinfo.FileArea ;
  If Paramstr(5) = 'Conf+Section' Then i := 1 ;
  Fwrite(Goxy(xpos,ypos+i)+Color(FLcol,BLcol)+FileAr[i].Name);
  Repeat
   Key := Readkey ;
   Case Key of
    #208 : Begin
            Fwrite(Goxy(xpos,ypos+i)+Color(Fcol,Bcol)+FileAr[i].Name);
            Inc(i);
            If i = FileMax+1 Then i := 1 ;
            Fwrite(Goxy(xpos,ypos+i)+Color(FLcol,BLcol)+FileAr[i].Name);
           End;
    #200 : Begin
            Fwrite(Goxy(xpos,ypos+i)+Color(Fcol,Bcol)+FileAr[i].Name);
            Dec(i);
            If i = 0 Then i := FileMax ;
            Fwrite(Goxy(xpos,ypos+i)+Color(FLcol,BLcol)+FileAr[i].Name);
           End;
   End; { Case }
  Until Key = #13 ;


  Assign(ExitFile,Paramstr(3)+'Exitinfo.Bbs');
  {$I-} Reset(ExitFile); {$I+}
  Rewrite(Exitfile);
  Erec.Userinfo.FileArea := FileAr[i].FreeSpace[1] ;
  Write(ExitFile,Erec);
  Close(ExitFile);
 End;

Procedure Conferences;
 Var
  Counter   : Byte ;
 Begin
  CountGroup;
  ReadInfo('Confs.Nfo');
  ShowGroup;
  If Erec.Userinfo.Group = 0 Then
   Begin
    Erec.Userinfo.Group := 1 ;
    Erec.Userinfo.Filearea := 1 ;
   End Else ;
  i := Erec.Userinfo.Group ;
  if i = 0 then i := 1 ;
  Fwrite(Goxy(xpos,ypos+i)+Color(FLcol,BLcol)+GroupAr[i].Name);
  WriteInfo;
  Repeat
   Key := Readkey ;
   Case Key of
    #208 : Begin
            Fwrite(Goxy(xpos,ypos+i)+Color(Fcol,Bcol)+GroupAr[i].Name);
            DeleteInfo;
            Inc(i);
            If i = GroupMax+1 Then i := 1 ;
            Fwrite(Goxy(xpos,ypos+i)+Color(FLcol,BLcol)+GroupAr[i].Name);
            WriteInfo;
           End;
    #200 : Begin
            Fwrite(Goxy(xpos,ypos+i)+Color(Fcol,Bcol)+GroupAr[i].Name);
            DeleteInfo;
            Dec(i);
            If i = 0 Then i := GroupMax ;
            Fwrite(Goxy(xpos,ypos+i)+Color(FLcol,BLcol)+GroupAr[i].Name);
            WriteInfo;
           End;
   End; { Case }
  Until Key = #13 ;

  Assign(ExitFile,Paramstr(3)+'Exitinfo.Bbs');
  {$I-} Reset(ExitFile); {$I+}
  Rewrite(Exitfile);
  Erec.Userinfo.Group := i ;
  CountFile ;
  Erec.Userinfo.Filearea := FileAr[1].FreeSpace[1] ;
  Write(ExitFile,Erec);
  Close(ExitFile);
 End;

Procedure Both;
 Var
  Teller  : Byte ;
 Begin
  Conferences;
  Fwrite(Color(8,0));
  For Teller := 24 Downto 1 do
   Begin
    Fwrite(goxy(1,1+Teller)+'[K');
   End;
  ClearScreen ;
  StartUp ;
  Section ;
 End;

Procedure JumpingJack;
 Var
  MnuRec  : MnuRecord ;
  MnuFile : File Of MnuRecord ;
  Count   : Byte ;
 Begin
  Conferences;
  Count := 0 ;
  Assign(MnuFile,ConfigRec.MenuPath+'DJump.Mnu');
  {$I-} Reset(MnuFile); {$I+}
  While Pos('JUMP',MnuRec.Display) = 0 Do
   Begin
    Inc(Count);
    Read(MnuFile,MnuRec);
   End;
  MnuRec.Typ := 4 ;
  MnuRec.MiscData := 'Conf'+i2s(i) ;
  Seek(MnuFile,2);
  Write(MnuFile,MnuRec);
  Truncate(MnuFile);
  Close(MnuFile);
 End;

Procedure Autojump ;
 Var
  MnuRec  : MnuRecord ;
  MnuFile : File Of MnuRecord ;
 Begin
  Assign(MnuFile,ConfigRec.MenuPath+'DJump.Mnu');
  {$I-} Reset(MnuFile); {$I+}
  While Pos('JUMP',MnuRec.Display) = 0 Do
   Begin
    Read(MnuFile,MnuRec);
   End;
  MnuRec.Typ := 4 ;
  MnuRec.MiscData := 'Conf'+i2s(Erec.Userinfo.Group) ;
  Seek(MnuFile,2);
  Write(MnuFile,MnuRec);
  Truncate(MnuFile);
  Close(MnuFile);
 End;

Begin { Main Program }
 StartUp;
 If Paramstr(5) = 'Conf' then Conferences ;
 If Paramstr(5) = 'Conf+Section' then Both ;
 If Paramstr(5) = 'Section' then Section ;
 If Paramstr(5) = 'Conf+Jump' then JumpingJack ;
 If Paramstr(5) = 'AutoJump' Then AutoJump ;
 ClearScreen;
 Fwrite(Goxy(1,1)+Color(7,0)+'You''ve Just Experienced Darsel');
 Fwrite(Goxy(1,2)+'a Damnation 95 Production By Valocity');
 Delay(50);

End.