        program last;

uses struct,crt;


const
  Kleur      : ARRAY [0..7] OF BYTE = (30,34,32,36,31,35,33,37);
  NewLine    = #13+#10;



var
 header    :Text;
 callers   :Lastcallrecord;
 Lastfile  :File of Lastcallrecord;
 F         :Text;
 teller    :byte;
 I         :Integer;
 Totalcalls:Integer;
 Totalnode1:Integer;
 Totalnode2:Integer;
 speedslowy:Integer;
 speednormal:integer;
 speedfast  :integer;
 speedmach1 :integer;
 speedhyper :integer;



FUNCTION i2s(int:longint):string;
VAR
  Tstr : STRING;
BEGIN
  str(int,Tstr);
  i2s:=Tstr;
END;



FUNCTION COLOR(F,B:BYTE):STRING;
VAR
  Tstr : STRING;
BEGIN
  IF F>7 THEN
    BEGIN
      Tstr:='1;';
      Dec(F,8);
    END
  ELSE Tstr:='0;';
  Tstr:=Tstr+i2s(kleur[f])+';'+i2s(kleur[b]+10)+'m';
  Color:='['+Tstr;
END;


FUNCTION GoXY(X,Y:BYTE):STRING;
BEGIN
  GoXY:='['+i2s(Y)+';'+i2s(X)+'H';
END;


function trunkit(st : string) :string;

begin
  trunkit := copy(st,1,20);
end;




FUNCTION w2s(int:word):string;
VAR
  Tstr : STRING;
BEGIN
  str(int,Tstr);
  w2s:=Tstr;
END;






FUNCTION Fill(St:STRING;Siz:BYTE;rechts:BOOLEAN):STRING;
VAR
  Tstr : STRING;
BEGIN
  Tstr:=St;
  WHILE LEngth(Tstr)<Siz DO
    IF rechts THEN
      Tstr:=' '+Tstr
    ELSE
      Tstr:=Tstr+' ';
  Fill:=Tstr;
END;






BEGIN
  Totalcalls := 0;
  Totalnode1 := 0;
  Totalnode2 := 0;
  Assign(Lastfile,'d:\ra\lastcall.bbs');
  {$I-} Reset(Lastfile); {$I+}
  if Ioresult <> 0 then
    begin
      writeln(' error with lastcall.bbs ');
      halt;
    end;
  Assign(F,'d:\ra\textfile\last.ans');
  {$I-} Reset(f); {$I+}
  If ioresult <> 0 then
    begin
     writeln(' error with last.ans, probably in use by other task');
     halt;
    end;
  Assign(Header,'d:\ra\header.ans');
  {$I-} Reset(Header); {$I+}


  rewrite(f);
  write(f,header);
  write(f,color(7,0));
  While not eof(lastfile) do
    begin
      read(lastfile,callers);
      if callers.baud > 0 then
        begin
          callers.handle := Trunkit(callers.handle);
          callers.handle := fill(callers.handle,21,false);
          write(f,color(8,0),'[',color(5,0),callers.line,color(8,0),']  ');
          write(f,color(5,0),callers.handle);
          write(f,fill (callers.city,25,false));
          if callers.baud > 28700 then write(f,color(13,0),'HyPeR    ') else
           if callers.baud > 24000 then write(f,color(13,0),'MaCH 1   ') else
            if callers.baud > 19200 then write(f,color(5,0),'FaST     ') else
             if callers.baud > 12000 then write(f,color(5,0),'NoRMaL   ') else
              write(f,color(5,0),'SLoWy    ');

          write(f,color(5,0),fill (callers.logon,6,false));
          write(f,fill (callers.logoff,7,false));
          if callers.times > 1 then write(f,fill (i2s(callers.times),7,false)) else
            write(f,color(13,0),fill ('NeW PaL',7,false));
          write(f,color(5,0));
          Case callers.baud of
             9600: inc(speedslowy);
            12000: inc(speednormal);
            14400: inc(speednormal);
            16800: inc(speednormal);
            19200: inc(speednormal);
            21600: inc(speedfast);
            24000: inc(speedfast);
            26400: inc(speedmach1);
            28800: inc(speedhyper);
           end;
          Inc(totalcalls);
          Case callers.line of
            1: inc(Totalnode1);
            2: inc(Totalnode2);
            end;
        end;
    end;
  Write(f,'[0m',Color(8,0)+    '...............................................................................'+newline);
  write(f,'[0m',color(5,0)+'DaMNaTiC FeVeRS oN NoDe 1 ',color(8,0),'['+color(13,0),totalnode1:3,color(8,0),']');
  write(f,color(7,0),' : ');
  write(f,'[0m',Color(5,0));
  write(f,'DaMNaTiC FeVeRS oN NoDe 2 ',color(8,0),'['+Color(13,0),Totalnode2:3,color(8,0),']');
  write(f,color(7,0),' : ');
  write(f,'[0m',color(5,0));
  write(f,'ToTaL ',color(8,0),'['+color(13,0),totalcalls:3,color(8,0),']',newline);
  write(f,'[0m',color(5,0));
  write(f,'CoNNeCTeD SPeeDS :      HyPeR',color(8,0),'['+color(13,0),speedhyper:3,color(8,0),']');
  write(f,'[0m',color(5,0));
  write(f,' MaCH 1',color(8,0),'['+color(13,0),speedmach1:3,color(8,0),']');
  write(f,'[0m',color(5,0));
  write(f,' FaST',color(8,0),'['+color(13,0),speedfast:3,color(8,0),']');
  write(f,'[0m',color(5,0));
  write(f,' NoRMaL',color(8,0),'['+color(13,0),speednormal:3,color(8,0),']');
  write(f,'[0m',color(5,0));
  write(f,' SLoWy',color(8,0),'['+color(13,0),speedslowy:3,color(8,0),']',newline);
  write(f,'[0m');
  Write(f,Color(8,0)+    '............................[_',color(7,0),' NoW SLaM THaT BaBe ');
  write(f,color(8,0),'_]...........................'+newline);
  close(f);
  close(lastfile);

end.

