Function UCase(S : String) : String;

Var X : Byte;

Begin
  For X := 1 To Length(S) Do
    S[X] := UpCase(S[X]);
  UCase := S
End; {Function UCase}

Procedure WriteXY(X,Y,Fore,Back : Byte;Tekst : String);
Begin
  GotoXY(X,Y);
  TextColor(Fore);
  TextBackGround(Back);
  Write(Tekst);
End;

Procedure CursorOff;
Var
   Regs : Registers;

Begin
  With Regs Do Begin
    AH :=$01;
    CH :=$20;
    CL :=$20;
  End;
  Intr($10, Regs);
End;

Procedure CursorSmall;

Var
   Regs : Registers;

Begin
  If LastMode <> CO80 Then Begin
    With Regs Do Begin
      AH := $01;
      CH := 12;
      CL := 13;
    End;
  End Else
  Begin
    With Regs Do Begin
      AH := $01;
      CH := 6;
      CL := 7;
    End;
  End;
  Intr($10, Regs);
End;

Function Invoer(X,Y,Fore,Back,MaxLength : Byte; Default : String;SpaceChar : Char) : String;
Var Finished : Boolean;
    Teken    : Char;
    Werk     : String;
    ColorStore : Byte;

Begin
  Werk := '';
  Finished := False;
  GotoXY(X,Y);
  TextBackGround(Back);
  TextColor(Fore);
  Werk := Default;
  Write(Default);
  CursorSmall;
  Repeat
    Repeat
    Until Keypressed;
    Teken := Readkey;
    Case Teken Of
      #0  : Teken := ReadKey;
      #8  : Begin
              If Length(Werk) <> 0
                Then
                  Begin
                    Delete(Werk, Length(Werk), 1);
                    GotoXY(WhereX -1, WhereY);
                    ColorStore := TextAttr;
                    TextColor(8);
                    Write(SpaceChar);
                    TextAttr := ColorStore;
                    GotoXY(WhereX - 1, WhereY);
                  End;
            End;
      #13 : Finished := True;
      #27 : Begin
              Werk := Default;
              Finished := True;
            End;
      #29..#255 : If Length(Werk) < MaxLength
                    Then Begin
                           Werk := Werk + Teken;
                           Write(Teken);
                         End
    End;
  Until Finished;
  WriteLn;
  Invoer := Werk;
  CursorOff
End;

Function NumberInvoer(X,Y,Fore,Back,MaxLength : Byte;
MinValue,MaxValue : LongInt; Default : LongInt;Opvulluh : Boolean; SpaceChar : Char) : LongInt;

Var Finished : Boolean;
    Teken    : Char;
    Werk     : String;
    ColorStore : Byte;
    DaNumbah : LongInt;
    ErrorCode : Integer;

Begin
  Werk := '';
  Finished := False;
  GotoXY(X,Y);
  TextBackGround(Back);
  TextColor(Fore);
  Str(Default,Werk);
  If Opvulluh Then
    Repeat
      If Length(Werk) < MaxLength Then Werk := '0' + Werk;
    Until Length(Werk) >= MaxLength;
  Write(Werk);
  CursorSmall;
  Repeat
    Repeat
    Until Keypressed;
    Teken := Readkey;
    Case Teken Of
      #0  : Teken := ReadKey;
      #8  : Begin
              If Length(Werk) <> 0
                Then
                  Begin
                    Delete(Werk, Length(Werk), 1);
                    GotoXY(WhereX -1, WhereY);
                    ColorStore := TextAttr;
                    TextColor(8);
                    Write(SpaceChar);
                    TextAttr := ColorStore;
                    GotoXY(WhereX - 1, WhereY);
                  End;
            End;
      #13 : Begin
              If ToGetal(Werk) >= MinValue Then
                Finished := True;
            End;
      #27 : Begin
              Str(Default,Werk);
              Finished := True;
            End;
      '0'..'9'     : If (Length(Werk) < MaxLength) AND NOT(ToGetal(Werk + Teken) > MaxValue)
                       Then Begin
                         Werk := Werk + Teken;
                         If (Werk[0] > #1) AND (Werk[1] = '0')
                           Then
                             Begin
                               Delete(Werk,1,1);
                               WriteXY(WhereX - Length(Werk),WhereY,15,0,Werk);
                               WriteXY(WhereX,WhereY,8,0,#249);
                               GotoXY(WhereX - 1, WhereY);
                               TextColor(Fore);
                             End
                           Else Write(Teken);
                       End
    End;
  Until Finished;
  WriteLn;
  Val(Werk,DaNumbah,ErrorCode);
  NumberInvoer := DaNumbah;
  CursorOff;
End;

Procedure HideRead(X,Y,Fore,Back : Byte; Var S : String; HideChar : Char; MaxLength : Byte;Default : String);

Var Finished : Boolean;
    Teken    : Char;
    ColorStore : Byte;

Begin
  GotoXY(X,Y);
  Textbackground(Back);
  TextColor(Fore);
  S := '';
  Finished := False;
  CursorSmall;
  Repeat
    Repeat
    Until Keypressed;
    Teken := ReadKey;
    Case Teken Of
      #08       : Begin
                    If Length(S) > 0 Then
                      Begin
                        Delete(S, Length(S), 1);
                        GotoXY(WhereX - 1, WhereY);
                        ColorStore := TextAttr;
                        TextColor(8);
                        Write(#249);
                        TextAttr := ColorStore;
                        GotoXY(WhereX - 1, WhereY);
                      End {Then}
                  End; {Case}
      #13       : Finished := True;
      #27 : Begin
              S := Default;
              Finished := True;
            End;
      #29..#254 : Begin
                    If Length(S) < MaxLength
                      Then Begin
                             S := S + Teken;
                             Write(HideChar);
                           End
                  End {Case}
    End; {Case statement}
  Until Finished;
  CursorOff
End; {Procedure HideRead}